﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _983371_RadSchedulerResourceSizing
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.radTrackBar1.Minimum = 1;
            this.radTrackBar1.Maximum = 10;
            this.radTrackBar1.ValueChanged += radTrackBar1_ValueChanged;

            DateTime baseDate = DateTime.Today;
            DateTime[] start = new DateTime[] { baseDate.AddHours(14.0), baseDate.AddDays(1.0).AddHours(9.0), baseDate.AddDays(2.0).AddHours(13.0) };
            DateTime[] end = new DateTime[] { baseDate.AddHours(16.0), baseDate.AddDays(1.0).AddHours(15.0), baseDate.AddDays(2.0).AddHours(17.0) };
            string[] summaries = new string[] { "Mr. Brown", "Mr. White", "Mrs. Green", };
            string[] descriptions = new string[] { "", "", "" };
            string[] locations = new string[] { "City", "Out of town", "Service Center" };
            AppointmentBackground[] backgrounds = new AppointmentBackground[] { AppointmentBackground.Business, AppointmentBackground.MustAttend, AppointmentBackground.Personal };

            this.radScheduler1.Appointments.BeginUpdate();
            Appointment appointment = null;

            appointment = new Appointment(baseDate.AddHours(11.0), baseDate.AddHours(12.0), "Wash the car", "", "Garage");
            appointment.RecurrenceRule = new DailyRecurrenceRule(baseDate.AddHours(11.0), 2);
            this.radScheduler1.Appointments.Add(appointment);
            this.radScheduler1.Appointments.EndUpdate();

            Color[] colors = new Color[]
            {
                Color.LightBlue, Color.LightGreen, Color.LightYellow,
                Color.Red, Color.Orange, Color.Pink, Color.Purple, Color.Peru, Color.PowderBlue
            };

            string[] names = new string[]
            {
                "Alan Smith", "Anne Dodsworth",
                "Boyan Mastoni", "Richard Duncan", "Maria Shnaider"
            };

            for (int i = 0; i < names.Length; i++)
            {
                Resource resource = new Resource();
                resource.Id = new EventId(i);
                resource.Name = names[i];
                resource.Color = colors[i];

                this.radScheduler1.Resources.Add(resource);
            }

            this.radScheduler1.GetDayView().ResourcesPerView = 3;
            this.radScheduler1.GroupType = GroupType.Resource;
            SchedulerDayViewGroupedByResourceElement headerElement = this.radScheduler1.SchedulerElement.ViewElement as SchedulerDayViewGroupedByResourceElement;
            headerElement.ResourceHeaderHeight = 135;

            for (int i = 0; i < summaries.Length; i++)
            {
                for (int j = 0; j < 10; j++)
                {
                    appointment = new Appointment(start[i], end[i], summaries[i],
                    descriptions[i], locations[i]);
                    appointment.ResourceId = this.radScheduler1.Resources[i].Id;
                    appointment.BackgroundId = (int)backgrounds[i];
                    this.radScheduler1.Appointments.Add(appointment);
                }
            }

            SchedulerDayViewGroupedByResourceElement dayView = this.radScheduler1.SchedulerElement.ViewElement as SchedulerDayViewGroupedByResourceElement;
            dayView.ScrollToWorkHours();

            this.radScheduler1.SchedulerElement.SetResourceHeaderAngleTransform(SchedulerViewType.Timeline, 0);

            this.radSchedulerNavigator1.AssociatedScheduler = this.radScheduler1;
            this.radScheduler1.SelectionBehavior.SelectDateRange(DateTime.Now.Date.AddHours(7), DateTime.Now.Date.AddHours(8), this.radScheduler1.Resources[0].Id);
        }

        private void radTrackBar1_ValueChanged(object sender, EventArgs e)
        {
            if (this.radScheduler1.SelectionBehavior.CurrentCellElement != null)
            {
                SchedulerViewGroupedByResourceElementBase viewGroupedByResource = this.radScheduler1.ViewElement as SchedulerViewGroupedByResourceElementBase;
                int resourceId = GetResourceIndex(viewGroupedByResource);
                if (resourceId >= 0)
                {
                    viewGroupedByResource.SetResourceSize(resourceId, this.radTrackBar1.Value);
                }
            }
        }

        private int GetResourceIndex(SchedulerViewGroupedByResourceElementBase viewGroupedByResource)
        {
            IResource cellResource = this.radScheduler1.SelectionBehavior.CurrentCellElement.View.GetResource();
            int cellResourceIndex = this.radScheduler1.Resources.IndexOf(cellResource);

            int resourceId = cellResourceIndex - viewGroupedByResource.ResourceStartIndex;
            return resourceId;
        }
    }
}
